/*******************************************************************************
 * FoxTeamInfo generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxTeamInfo extends TeamInfo
    native(AI)
    hidecategories(Navigation,Movement,Collision);

enum EDSPStatus
{
    DSP_WAIT,
    DSP_FOUND,
    DSP_NOTFOUND,
    DSP_MAX
};

struct native TeamBoost
{
    var float BoostMultiplier;
    var int BoostUnlockID;
    var FoxPRI PRIOwner;

    structdefaultproperties
    {
        BoostMultiplier=0.0
        BoostUnlockID=0
        PRIOwner=none
    }
};

var transient array<FoxSquadInfo> Squads;
var private transient FoxTeamInfo.EDSPStatus DspStatus;
var LinearColor HudColor;
var private const transient int LastCheckScore;
var() const LinearColor EnemyTeamEmissive;
var() const LinearColor FriendlyTeamEmissive;
var() const Color FriendlyTeamColor;
var() const Color EnemyTeamColor;
var() LinearColor BlueTeamHVTColor;
var() LinearColor RedTeamHVTColor;
var() name HVTColorParameterName;
var() LinearColor BlueTeamHVTIconColor;
var() LinearColor RedTeamHVTIconColor;
var() name HVTIconParameterName;
var() const array<string> DialogNames;
var int HumanSize;
var int BotSize;
var int ValidPlayerSize;
var int NumCapturedPoints;
var TeamBoost DefaultTeamModifier;
var TeamBoost TeamBoostModifiers[EBoostModifierType];
var int RoundsWon;
var int RunningTotalScore;
var int FinalRunningTotalScore;
var int FinalScore;
var int RemainingTeamSpawnTickets;

replication
{
    // Pos:0x000
    if(bNetInitial && Role == ROLE_Authority)
        HudColor

    // Pos:0x020
    if(bNetDirty && Role == ROLE_Authority)
        BotSize, HumanSize, 
        NumCapturedPoints, RemainingTeamSpawnTickets, 
        RoundsWon, RunningTotalScore, 
        TeamBoostModifiers, ValidPlayerSize
}

simulated event Destroyed()
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x53 [Loop If]
    if(I < Squads.Length)
    {
        Squads[I].Destroy();
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    Squads.Length = 0;
    super.Destroyed();
    //return;    
}

simulated function LinearColor GetFoxHUDColor()
{
    return HudColor;
    //return ReturnValue;    
}

function bool AddToTeam(Controller Other)
{
    local bool bResult;
    local FoxAIControllerInterface Ctrl;

    bResult = super.AddToTeam(Other);
    // End:0xC4
    if(FoxPRI(Other.PlayerReplicationInfo).IsValidPlayer())
    {
        ++ ValidPlayerSize;
        // End:0xB9
        if(!FoxPRI(Other.PlayerReplicationInfo).bPlayerBot)
        {
            ++ HumanSize;
        }
        // End:0xC4
        else
        {
            ++ BotSize;
        }
    }
    // End:0x19C
    if(bResult)
    {
        Ctrl = FoxAIControllerInterface(Other);
        // End:0x188
        if(Ctrl != none)
        {
            // End:0x168
            if(WorldInfo.Game.bTeamGame)
            {
                AddToSquad(Ctrl, Ctrl.GetSquadNum());
            }
            // End:0x185
            else
            {
                AddToSquad(Ctrl, FindFreeSquadIndex());
            }
        }
        // End:0x19C
        else
        {
            AddToSquad(Other, 0);
        }
    }
    return bResult;
    //return ReturnValue;    
}

function RemoveFromTeam(Controller Other)
{
    local FoxAIControllerInterface Ctrl;

    super.RemoveFromTeam(Other);
    // End:0x16F
    if(FoxPRI(Other.PlayerReplicationInfo).IsValidPlayer() || Other.PlayerReplicationInfo.bIsInactive && !Other.PlayerReplicationInfo.bBot || FoxPRI(Other.PlayerReplicationInfo).bPlayerBot)
    {
        -- ValidPlayerSize;
        // End:0x164
        if(!FoxPRI(Other.PlayerReplicationInfo).bPlayerBot)
        {
            -- HumanSize;
        }
        // End:0x16F
        else
        {
            -- BotSize;
        }
    }
    Ctrl = FoxAIControllerInterface(Other);
    // End:0x1CF
    if(Ctrl != none)
    {
        RemoveFromSquad(Ctrl, Ctrl.GetSquadNum());
    }
    // End:0x1E3
    else
    {
        RemoveFromSquad(Other, 0);
    }
    //return;    
}

function bool AddToSquad(Controller Other, int SquadIndex)
{
    local FoxSquadInfo Info;

    // End:0x3D
    if((SquadIndex < 0) || SquadIndex > Squads.Length)
    {
        SquadIndex = Squads.Length;
    }
    // End:0x86
    if((SquadIndex >= 0) && SquadIndex < Squads.Length)
    {
        Info = Squads[SquadIndex];
    }
    // End:0x110
    else
    {
        Info = Spawn(class'FoxSquadInfo');
        Info.Team = self;
        Info.SquadIndex = Squads.Length;
        Squads[Squads.Length] = Info;
    }
    Info.AddMemberToSquad(Other);
    return true;
    //return ReturnValue;    
}

function RemoveFromSquad(Controller Other, int SquadIndex)
{
    local int Idx;

    // End:0xAB
    if((SquadIndex >= 0) && SquadIndex < Squads.Length)
    {
        Idx = Squads[SquadIndex].FindSquadMember(Other);
        // End:0xAB
        if(Idx != -1)
        {
            Squads[SquadIndex].RemoveMemberFromSquad(Other);
        }
    }
    //return;    
}

function int FindFreeSquadIndex()
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x6A [Loop If]
    if(I < Squads.Length)
    {
        // End:0x5C
        if(Squads[I].SquadMembers.Length == 0)
        {
            return I;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    return Squads.Length + 1;
    //return ReturnValue;    
}

event Reset()
{
    NumCapturedPoints = 0;
    //return;    
}

// Export UFoxTeamInfo::execFindFreeSquad(FFrame&, void* const)
native function int FindFreeSquad(const int MinMembers);

// Export UFoxTeamInfo::execFindNamedSquad(FFrame&, void* const)
native function int FindNamedSquad(const name SquadName);

// Export UFoxTeamInfo::execIssueSquadCommand(FFrame&, void* const)
native function IssueSquadCommand(const int SquadIndex, const FoxSquadInfo.ESquadCommandType Cmd, Actor ActorRef, const Vector VectorRef);

simulated function string GetDialogName()
{
    return DialogNames[TeamIndex];
    //return ReturnValue;    
}

function BuildFromMigratedInfo(SavedTeamInfo SavedTeam)
{
    Score = float(SavedTeam.Score);
    RoundsWon = SavedTeam.RoundsWon;
    RunningTotalScore = SavedTeam.RunningTotalScore;
    FinalRunningTotalScore = SavedTeam.FinalRunningTotalScore;
    FinalScore = SavedTeam.FinalScore;
    //return;    
}

defaultproperties
{
    HudColor=(R=0.0,G=0.0,B=0.0,A=1.0)
    EnemyTeamEmissive=(R=0.0,G=0.150,B=2.0,A=1.0)
    FriendlyTeamEmissive=(R=2.0,G=0.650,B=0.0,A=1.0)
    FriendlyTeamColor=(R=0,G=213,B=255,A=255)
    EnemyTeamColor=(R=255,G=106,B=0,A=255)
    BlueTeamHVTColor=(R=3.0,G=5.0,B=0.0,A=1.0)
    RedTeamHVTColor=(R=0.0,G=0.10,B=5.0,A=1.0)
    HVTColorParameterName=Color
    BlueTeamHVTIconColor=(R=1.0,G=0.940,B=0.0,A=1.0)
    RedTeamHVTIconColor=(R=0.0,G=0.10,B=1.0,A=1.0)
    HVTIconParameterName=HRVMeterColor
    DialogNames(0)="Order"
    DialogNames(1)="Blacklight"
    DialogNames(2)="Spectator"
    DefaultTeamModifier=(BoostMultiplier=1.0,BoostUnlockID=0,PRIOwner=none)
}